package org.RTFlex 
{
    public class Format extends Object
    {
        public function Format()
        {
            super();
            return;
        }

        public function formatText(arg1:String, arg2:int, arg3:int, arg4:int, arg5:Boolean=true):String
        {
            var loc1:*="{";
            if (this.makeParagraph) 
            {
                loc1 = loc1 + "\\pard";
            }
            if (this.lineSpacing != 0) 
            {
                loc1 = loc1 + ("\\sl" + int(this.lineSpacing * 240).toString() + "\\smult1");
            }
            if (arg4 > 0) 
            {
                loc1 = loc1 + ("\\f" + arg4.toString());
            }
            if (arg3 > 0) 
            {
                loc1 = loc1 + ("\\cb" + (arg3 + 1).toString());
            }
            if (arg2 > 0) 
            {
                loc1 = loc1 + ("\\cf" + (arg2 + 1).toString());
            }
            if (this.fontSize > 0) 
            {
                loc1 = loc1 + ("\\fs" + (this.fontSize * 2).toString());
            }
            var loc2:*=this.align;
            switch (loc2) 
            {
                case org.RTFlex.Align.CENTER:
                {
                    loc1 = loc1 + "\\qc";
                    break;
                }
                case org.RTFlex.Align.LEFT:
                {
                    loc1 = loc1 + "\\ql";
                    break;
                }
                case org.RTFlex.Align.FULL:
                {
                    loc1 = loc1 + "\\qj";
                    break;
                }
                case org.RTFlex.Align.RIGHT:
                {
                    loc1 = loc1 + "\\qr";
                    break;
                }
            }
            if (this.bold) 
            {
                loc1 = loc1 + "\\b";
            }
            if (this.italic) 
            {
                loc1 = loc1 + "\\i";
            }
            if (this.underline) 
            {
                loc1 = loc1 + "\\ul";
            }
            if (this.strike) 
            {
                loc1 = loc1 + "\\strike";
            }
            if (this.leftIndent > 0) 
            {
                loc1 = loc1 + ("\\li" + this.leftIndent.toString());
            }
            if (this.rightIndent > 0) 
            {
                loc1 = loc1 + ("\\ri" + this.rightIndent.toString());
            }
            if (this.subScript) 
            {
                loc1 = loc1 + "\\sub";
            }
            if (this.superScript) 
            {
                loc1 = loc1 + "\\super";
            }
            if (arg5) 
            {
                loc1 = loc1 + (" " + this.getRTFSafeText(arg1));
            }
            else 
            {
                loc1 = loc1 + arg1;
            }
            if (this.makeParagraph) 
            {
                loc1 = loc1 + "\\par";
            }
            return loc1 = loc1 + "}";
        }

        internal function getRTFSafeText(arg1:String):String
        {
            var loc2:*=null;
            var loc3:*=null;
            var loc1:*=arg1;
            if (loc1 == null) 
            {
                return "";
            }
            loc1 = loc1.split("\\").join("\\\\");
            loc1 = loc1.split("{").join("\\{");
            loc1 = loc1.split("}").join("\\}");
            loc1 = loc1.split("~").join("\\~");
            loc1 = loc1.split("-").join("\\-");
            loc1 = loc1.split("_").join("\\_");
            loc1 = loc1.split("\n\r").join(" \\line ");
            loc1 = loc1.split("\n").join(" \\line ");
            loc1 = loc1.split("\r").join(" \\line ");
            loc1 = loc1.split("\t").join(" \\tab ");
            loc1 = loc1.replace(new RegExp("#sl#", "g"), "\\");
            var loc4:*=0;
            var loc5:*=org.RTFlex.RTF.getSymbolCollection();
            for each (loc3 in loc5) 
            {
                loc2 = new RegExp(loc3.aliasPattern, "g");
                loc1 = loc1.replace(loc2, loc3.getRTFCode());
            }
            return loc1;
        }

        public var underline:Boolean=false;

        public var bold:Boolean=false;

        public var italic:Boolean=false;

        public var strike:Boolean=false;

        public var superScript:Boolean=false;

        public var subScript:Boolean=false;

        public var makeParagraph:Boolean=false;

        public var align:String="";

        public var leftIndent:int=0;

        public var rightIndent:int=0;

        public var font:String="";

        public var fontSize:int=0;

        public var color:org.RTFlex.RGB;

        public var backgroundColor:org.RTFlex.RGB;

        public var lineSpacing:int=0;

        public var url:String;
    }
}
